#ifndef NORMARIZE_POINTS_INTERVAL_H
#define NORMARIZE_POINTS_INTERVAL_H

/*!
  \file
  \brief 点列の間隔を均等にする

  \author Satofumi KAMIMURA

  \attention 点と点の間隔が狭いときに間引く機能しか実装していない

  $Id: normarizePointsInterval.h 222 2008-09-17 12:52:15Z satofumi $
*/

#include "GridTypes.h"
#include <vector>


namespace qrk
{
  void normarizePointsInterval(std::vector<Grid<long> >& points,
                               int min_interval = 15);
};

#endif /* !NORMARIZE_POINTS_INTERVAL_H */
