#ifndef MOTOR_T_H
#define MOTOR_T_H

/*!
  \file
  \brief モータ制御構造体

  \author Satofumi KAMIMURA

  $Id: motor_t.h 222 2008-09-17 12:52:15Z satofumi $
*/

#include "servo_mode.h"
#include "rotational_direction.h"


typedef struct
{
  char id;                                  //!< モータ ID
  ServoMode servo_mode;                     //!< 設定中のサーボ状態
  RotationalDirection rotational_direction; //!< モータの回転方向

  // 制御パラメータ
  // !!! P ゲイン
  // !!! I ゲイン

  // モータ固有パラメータ
  // !!!

} motor_t;

#endif /* !MOTOR_T_H */
