/*!
  \file
  \brief sci_readable() の動作テスト

  \author Satofumi KAMIMURA

  $Id: readable.c 246 2008-09-30 11:39:48Z satofumi $
*/

#include "sci_get.h"
#include "sci_put.h"
#include "timer_ctrl.h"
#include "imask_ctrl.h"


enum {
  SCI_PORT = SCI_1,
  TIMER_PORT = TIMER_0,
};


static void timer_handler(void) {
  static int msec = 0;
  static int sec = 0;

  ++msec;
  if (msec >= 1000) {
    ++sec;
    msec = 0;

    sci_puts(SCI_PORT, "readable: ");
    sci_putint(SCI_PORT, sci_readable(SCI_PORT));
    sci_puts(SCI_PORT, "\r\n");
  }
}


void __main(void) {}
int main(void) {

  sci_initialize(SCI_PORT, 6);
  imask_setMaskLevel(0);

  sci_puts(SCI_PORT, "input characters.\r\n");

  timer_initialize(TIMER_PORT, 4, 1000, timer_handler);
  timer_start(TIMER_PORT);

  while (1)
    ;
}
