#ifndef VOLUME_CTRL_H
#define VOLUME_CTRL_H

/*!
  \file
  \brief 音量の調整

  \author Satofumi KAMIMURA

  $Id: VolumeCtrl.h 167 2008-08-24 01:01:01Z satofumi $
*/

#include <memory>


namespace qrk
{
  class VolumeCtrl
  {
    VolumeCtrl(const VolumeCtrl& rhs);
    VolumeCtrl& operator = (const VolumeCtrl& rhs);

    struct pImpl;
    pImpl* pimpl;

  public:
    VolumeCtrl(void);
    ~VolumeCtrl(void);


    /*!
      \brief 全体の音量設定

      \param[in] percent 音量の設定割合

      \attention 未実装
    */
    void setVolume(size_t percent);


    /*!
      \brief ミュート指定

      \attention 未実装
    */
    void mute(void);
  };
};

#endif /* !VOLUME_CTRL_H */
