#ifndef LOG_RECORD_WIDGET_H
#define LOG_RECORD_WIDGET_H

/*!
  \file
  \brief コマンド応答の記録

  \author Satofumi KAMIMURA

  $Id: LogRecordWidget.h 218 2008-09-12 22:24:26Z satofumi $
*/

#include "ui_LogRecordWidgetForm.h"


class LogRecordWidget : public QWidget, private Ui::LogRecordWidgetForm
{
  Q_OBJECT;

  LogRecordWidget(const LogRecordWidget& rhs);
  LogRecordWidget& operator = (const LogRecordWidget& rhs);

  struct pImpl;
  std::auto_ptr<pImpl> pimpl;

private slots:
  void rescan(void);
  void connectCom(void);
  void disconnectCom(void);
  void updateCount(void);
  void sendCommand(void);
  void toggledIntervalButton(bool);
  void initialize(void);

public:
  LogRecordWidget(QWidget* parent = 0);
  ~LogRecordWidget(void);
};

#endif /* !LOG_RECORD_WIDGET_H */
